################################################## 
# GWSDL_types.py
# generated josh, this provides the gwsdl types
# 
# 
##################################################

import ZSI
from ZSI import _seqtypes
from pyGridWare.ogsi import TCmodified
from pyGridWare.ogsi.TCmodified import AnyElement, Struct


class www_gridforum_org_namespaces_2003_03_serviceData:
    targetNamespace = 'http://www.gridforum.org/namespaces/2003/03/serviceData'
    kw = {\
        'inorder':0,
        'unique':1,
        'typed':1,
        targetNamespace:'wwwg_name_2003_03_serv',
        }

    class ServiceDataValuesElementType_Def(Struct):
        def __init__(self, pname, **kw):
            if type(pname) in _seqtypes:
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            Struct.__init__(self, 
                pyclass=self.__class__, 
                ofwhat=[AnyElement(repeatable=1,optional=1)],
                pname=pname,
                aname=aname,
                hasextras=1, 
                **kw)

    ServiceDataValuesElementType_Def.schema = targetNamespace
    ServiceDataValuesElementType_Def.type = (targetNamespace,'ServiceDataValuesElementType')

    class ServiceDataValuesElement_Dec(ServiceDataValuesElementType_Def):
        literal = "serviceDataValues"

        def __init__(self, name=None, ns=None, **kw):
            name = self.__class__.literal
            ns = ns or self.__class__.schema

            kw.update(ns1.kw)
            pname = (ns,name)

            ns1.ServiceDataValuesElementType_Def.__init__(self, pname=pname, **kw)
            self.typecode = ns1.ServiceDataValuesElementType_Def(pname, **kw)

    ServiceDataValuesElement_Dec.schema = targetNamespace


    class ServiceDataValuesType_Def(Struct):
        schema = 'http://www.gridforum.org/namespaces/2003/03/serviceData'

        def __init__(self, name, ns=None, **kw):
            if type(pname) in _seqtypes:
                aname = "_%s" % pname[1]
            else:
                aname = "_%s" % pname
                pname = (self.schema,pname)

            kw.update(ns1.kw)
            if not kw.has_key('type'):
                kw['type'] = self.type

            Struct.__init__(self, 
                pyclass=self.__class__, 
                ofwhat=[AnyElement()],
                pname=pname,
                aname=aname,
                hasextras=1, 
                **kw)

    ServiceDataValuesType_Def.schema = targetNamespace
    ServiceDataValuesType_Def.type = (targetNamespace, 'ServiceDataValuesType')


ns1 =  www_gridforum_org_namespaces_2003_03_serviceData



###############################################################################
#  BELOW -- TESTING
###############################################################################
def main():
    pyobj = getFindServiceDataOutputMessage('TESTING')
    print "MSG: ", pyobj
    """
    pyobj = FindByHandleOutputMessage()
    del pyobj.typecode

    pyobj._locator._reference = ns1.WSDLReferenceType(name='reference')
    try:
        pyobj._locator._reference._dom = getWSDLDefinitionDOM()
    except Exception, ex:
        print ex
        return
    del pyobj.__class__.typecode.ofwhat[0].typecode

    pyobj.__class__.typecode.ofwhat[0].oname = '%s  %s  %s' %('locator',
        'xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"',
        'xsi:type="ns1:LocatorType"')

    #COPY IT TO DERIVED TYPE
    pyobj.__class__.typecode.ofwhat[0].ofwhat[1].oname = '%s  %s  %s' %('reference',
        'xmlns:ns1="http://www.gridforum.org/namespaces/2003/03/OGSI"',
        'xsi:type="ns1:WSDLReferenceType"')
    pyobj._locator._reference.oname = pyobj.__class__.typecode.ofwhat[0].ofwhat[1].oname

    """
    s = StringIO()
    sw = ZSI.SoapWriter(s)
    sw.serialize(pyobj)
    print "RESULT -----\n", s.getvalue()

if __name__ == '__main__':
    main()

